VERSION 5.00
Object = "{EAB22AC0-30C1-11CF-A7EB-0000C05BAE0B}#1.1#0"; "SHDOCVW.DLL"
Begin VB.Form frmHTML 
   Caption         =   "HTML Resource Sample"
   ClientHeight    =   5925
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8535
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "HTML Display.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5925
   ScaleWidth      =   8535
   StartUpPosition =   2  'CenterScreen
   Begin SHDocVwCtl.WebBrowser brwRes 
      Height          =   3015
      Left            =   53
      TabIndex        =   0
      Top             =   90
      Width           =   4575
      ExtentX         =   8070
      ExtentY         =   5318
      ViewMode        =   0
      Offline         =   0
      Silent          =   0
      RegisterAsBrowser=   0
      RegisterAsDropTarget=   1
      AutoArrange     =   0   'False
      NoClientEdge    =   0   'False
      AlignLeft       =   0   'False
      ViewID          =   "{0057D0E0-3573-11CF-AE69-08002B2E1262}"
      Location        =   ""
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Visible         =   0   'False
      Begin VB.Menu mnuFileAbout 
         Caption         =   "&About "
      End
   End
End
Attribute VB_Name = "frmHTML"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'------------------------------------------------------------------------------------------
'
'   Form           : HTML Resource Interface Sample
'   Author         : Eswar Santhosh
'   Last Updated   : 15th February, 2000
'
'   Requirements   : Requires sSubTmr6.dll (Steve McMahon) http:\\www.vbaccelerator.com
'                    Included in the Zip file.
'
'   Notes          : Shows you how to :
'                    1. Use HTML Pages as Resources
'                    2. Design Interface using HTML Pages
'                    3. Some Common UI (you can find code elsewhere on the net) hacks.
'
'                    This is not a Web Browser Form Sample. So, you won't find Toolbars and Statusbars
'
'
'   Warning :
'
'   This code can be distributed only in compiled form. It may not be distributed in Source form
'   to any public distribution methods like web sites, BBS's, CD-ROMs, DVD's etc., The code may not
'   be posted as your code. The author's express permission is
'   required for distributing this code as part of your source code projects.
'
'   Web Site : http:\\eswar_santhosh.tripod.com
'   Mail     : eswar_santhosh@yahoo.com
'
'
'------------------------------------------------------------------------------------------

Option Explicit

'
' API Constants
'
Private Const GW_CHILD = 5
Private Const GW_HWNDNEXT = 2
Private Const WM_GETMINMAXINFO = &H24
Private Const WM_MOUSEACTIVATE = &H21
Private Const WM_RBUTTONDOWN = &H204            ' never got this message with Browser window

'
' API Types
'
Private Type POINTAPI
        x As Long
        y As Long
End Type

Private Type MINMAXINFO
        ptReserved As POINTAPI
        ptMaxSize As POINTAPI
        ptMaxPosition As POINTAPI
        ptMinTrackSize As POINTAPI
        ptMaxTrackSize As POINTAPI
End Type

'
' API Declarations
'
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
(Destination As Any, Source As Any, ByVal Length As Long)

Private Declare Function GetWindow Lib "user32" _
(ByVal hwnd As Long, ByVal wCmd As Long) As Long

Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" _
(ByVal hwnd As Long, ByVal lpClassName As String, _
ByVal nMaxCount As Long) As Long

'
' For Sub-Classing
'
Implements ISubclass

'
' Local Variables
'
Dim hBrwWnd As Long         ' The Browser Window
Dim m_emr As EMsgResponse   ' We Consume the message

Private Sub Form_Load()
'
' Start Sub-classing
'
Dim gClassName As String        ' To get the Windows' Class Name
Dim lenClassName As Long        ' Length of the Class
Dim hwndChild As Long           ' Child Window

AttachMessage Me, Me.hwnd, WM_GETMINMAXINFO
    
' For Finding the "real" Browser Window. If you really want to know
' why, that's because brwRes.hwnd returned an Automation Error.
hwndChild = GetWindow(Me.hwnd, GW_CHILD)
   
Do While hwndChild <> 0
    gClassName = Space$(255)
    lenClassName = GetClassName(hwndChild, gClassName, 255)
    If lenClassName > 0 Then
        gClassName = Left$(gClassName, lenClassName)
        If gClassName = "Shell Embedding" Then
            hBrwWnd = hwndChild
            Exit Do
        Else
            ' Needed if you have more controls on the form
            hwndChild = GetWindow(hwndChild, GW_HWNDNEXT) ' get the next child window
        End If
    End If
Loop

' I tried to add the easier choice, WM_RBUTTONDOWN message. But, the control never seemed to
' get the Message. After sometime (with Spy++), I figured out that WM_MOUSEACTIVATE
' is the message to be captured.
AttachMessage Me, hBrwWnd, WM_MOUSEACTIVATE

' Now the easier part. Navigate to Home Page
brwRes.Navigate2 "res://" & App.Path & "\rcHTML.dll/HOME"
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
' Stop Subclassing
    DetachMessage Me, Me.hwnd, WM_GETMINMAXINFO
    DetachMessage Me, hBrwWnd, WM_RBUTTONDOWN
End Sub

Private Sub Form_Resize()
'
' Resize the Browser Control accordingly
'
If Me.WindowState <> vbMinimized Then
    brwRes.Move brwRes.Left, brwRes.Top, ScaleWidth - (brwRes.Left * 2), ScaleHeight - (brwRes.Top * 2)
End If
End Sub

Private Property Let ISubclass_MsgResponse(ByVal RHS As SSubTimer6.EMsgResponse)
    m_emr = RHS
End Property

Private Property Get ISubclass_MsgResponse() As SSubTimer6.EMsgResponse
    m_emr = emrConsume
    ISubclass_MsgResponse = m_emr
End Property

Private Function ISubclass_WindowProc(ByVal hwnd As Long, ByVal iMsg As Long, _
ByVal wParam As Long, ByVal lParam As Long) As Long
'
' Process Messages
'
Dim iMinMax As MINMAXINFO, msgMouse As Long

If hwnd = Me.hwnd Then
    If iMsg = WM_GETMINMAXINFO Then
        ' Process WM_GETMINMAXINFO to set the minimum size of the Form.
        ' lParam contains this structure
        CopyMemory iMinMax, ByVal lParam, LenB(iMinMax)
        
        iMinMax.ptMinTrackSize.x = 200          ' Remember these values are in Pixels
        iMinMax.ptMinTrackSize.y = 200
        
        CopyMemory ByVal lParam, iMinMax, LenB(iMinMax)
    End If
    
ElseIf hwnd = hBrwWnd Then
    If iMsg = WM_MOUSEACTIVATE Then
        '
        ' If you leave it without the following block of code, the menu will
        ' Popup with *all* mouse button clicks : Right, Left and Middle (if you have).
        ' We need to process the High order "word" of the lParam : This returns the Message Identifier
        '
        CopyMemory msgMouse, ByVal VarPtr(lParam) + 2, 2&
        
        If msgMouse = WM_RBUTTONDOWN Then
            Me.PopupMenu mnuFile
        End If
    End If
End If

End Function

Private Sub mnuFileAbout_Click()
' Show the About Page
brwRes.Navigate2 "res://" & App.Path & "\rcHTML.dll/ABOUT"
End Sub
